#include <iostream>
using namespace std;

//variables

unsigned int count = 0, old_score = 0;

//  bins configuration
unsigned int bins[10] = {3,3,2,0,0,0,0,0,0,0};  

//Bins have values 1,1,2,3,3,4,4,5,6,6
unsigned int values[10] = {1,1,2,3,3,4,4,5,6,6};


//functions

unsigned int done(void);
unsigned int score_low(void);
unsigned int number_of_threes(void);
void process(unsigned int threes);
void get_next_bin(void); 


//numerator and denominator for the final answer

unsigned long long int ans_numerator = 0;
unsigned long long int ans_denominator = 1;


int main(void)
{
        int count = 0;
	//let's go ahead and set our denominator
	for(int n = 0; n <8; n++)
		ans_denominator *= 10;
	ans_denominator *= (9 * 9 * 9 * 9 * 9 * 8 * 8);

	
	//main loop
	while(!done())
	{	
		if(score_low())
		{
			count++;
			process(number_of_threes());
		}
		
		get_next_bin();

	}
	
	//double the answer, because by symmetry, 
	// P(win with low score) = P(win with high score)

	ans_numerator *= 2;

	// Print the results
	
	cout << "\n\n********************************";
	cout << "\n\n***ANSWER***\n"; 
	cout << ans_numerator << "  /  " << ans_denominator;
	cout << "\n\n********************************\n";

	return 0;
}


unsigned int score_low()
{
	unsigned int score = 0;
	for(int n = 0; n < 10; n++)
		score += values[n] * bins[n];

	if(score < 16)
		return 1;

	return 0;
}

	
unsigned int done(void)
{	
	if(bins[9] == 3)
		if(bins[8] == 3)
			if(bins[7] == 2)
				return 1;
	return 0;
}


void get_next_bin()
{
	//fairly standard greedy routine 
	//for generating things like permutations, in lex-order
	 
	int i;
	for(i = 8; i >= 0; i--)
	{
		if(bins[i] > 0 && bins[i+1] < 3)
			break;
	}
	
	bins[i]--;
	bins[i+1]++;
	
	for(int j = i+1; j < 9; j++)
	{
		for(int m = j+1; m < 10; m++)
			while(bins[j] < 3 && bins[m] > 0)
			{
				bins[j]++;
				bins[m]--;
			}
	
	}
	
	return;
}


void process(unsigned int num_threes)
{
	unsigned long long int working_sum = 0;
	unsigned long long int multiplier;
       	
	if(num_threes == 0)
	{
		multiplier = 9 * 9 * 9 * 9 * 9 * 8 * 8;  
		// multiplier will cancel out five 9's and two 8's 
		// from ans_denominator, which will leave eight 10's
		
		working_sum = 8 * 7 * 6 * 5 * 4 * 3 * 2;

		for(int n = 0; n < 10; n++)
			if(bins[n] == 2)
				working_sum /= 2;

		ans_numerator += multiplier * working_sum;

	}  //end num_threes == 0
	
	if(num_threes == 1)
	{
		//third denotes which ball 3-8 is the "third"
		for(unsigned int third = 3; third <= 8; third++)
		{		
			unsigned int a = (third - 1)*(third - 2) / 2;
			working_sum = a * 5 * 4 * 3 * 2;
			
			for(int n = 0; n < 10; n++)
			{
				if(bins[n] == 2)
					working_sum /=2;
			}

			multiplier = 8 * 8 * 10 * 10 * 10 * 10 * 10;
			// multiplier will cancel everything from  
			// ans_denominator except three 10's, and five 9's 

			for(int N = 4; N <= third; N++)
			{	
				// exchange 10's for 9's, as needed
				multiplier /= 10;
				multiplier *= 9;
				
			}

			ans_numerator += working_sum * multiplier;				
		}

	}  //end num_threes == 1
	
	if(num_threes == 2)
	{
		// we need to multiply this contribution by 2
		// to cover the symmetric case third2 < third1
		
		for(unsigned int third1 = 3; third1 <= 7; third1++)
		for(unsigned int third2 = third1+1; third2 <=8; third2++)
		{
			unsigned int a = (third1 - 1) * (third1 - 2) / 2;
			unsigned int b = (third2 - 4) * (third2 - 5) / 2;
			working_sum = a * b * 2;

			for(int n = 0; n < 10; n++)
				if(bins[n] == 2)
					working_sum /= 2;

			// we will cancel appropriate factors
			// from ans_denominator, by constructing the factors
			// we wish to keep, and storing them in prob_denom

			unsigned long long int prob_denom = 1;

			for(int N = 1; N <= 8; N++)
			{
				if(N > third2)
				{
					prob_denom *= 8;
				}
				else 
				{
					if(N > third1)
					{
						prob_denom *= 9;
					}
					else
						prob_denom *= 10;
				}
			}	
			
			multiplier = ans_denominator / prob_denom;
			ans_numerator += 2 * multiplier * working_sum;

		}
		
	}  //end num_threes == 2
	
	return;
}


unsigned int number_of_threes(void)
{
	unsigned int threes = 0;
	
	for(int n=0; n<10; n++)
		if(bins[n] == 3)
			threes++;

	return threes;
}

